var gulp = require('gulp'),
    mkdirp = require('mkdirp'),
    jsdox = require('jsdox'),
    uglify = require('gulp-uglify'),
    rename = require('gulp-rename'),
    rimraf = require('gulp-rimraf');

gulp.task('removeScripts', function (){
    return gulp.src('./dist/*.js', {read: false})
        .pipe(rimraf());
});

gulp.task('genDoc', ['changeExt'], function () {
    var outputDir = './docs';
    mkdirp.sync(outputDir);
    return jsdox.generateForDir('./src', outputDir, undefined, function () {
        return false;
    });
});

gulp.task('moveFiles', function () {
    return gulp.src('./src/*.js')
        .pipe(gulp.dest('dist'));
});

gulp.task('changeExt', ['moveFiles'], function () {
    return gulp.src('./dist/*.js')
        .pipe(rename({
            suffix: '.min',
            extname: '.js'
        })) 
        .pipe(gulp.dest('dist'));
});

gulp.task('build', ['genDoc', 'changeExt'], function () {
    return gulp.src('./dist/*.min.js')
        .pipe(uglify()) 
        .pipe(gulp.dest('./dist'));
});

gulp.task('default', ['removeScripts', 'build']);